module SPI_SET_2CH  (
   input OSC_50 , 
   input RESET_N,  
   inout ADC1_SDIO_DCS ,
   inout ADC1_CSB      ,
   inout ADC1_SCLK_DFS ,
   inout ADC2_SDIO_DCS ,
   inout ADC2_CSB      ,
   inout ADC2_SCLK_DFS ,
   output [7:0] CHIP_ID2 ,
   output [7:0] CHIP_ID1,
   output [7:0] CHIP_RADE2 ,
   output [7:0] CHIP_RADE1,
   output READY1,
   output READY2

); 
//======WIRE/REG=====
reg [7:0]   TIME;
wire [7:0]  RESET ;
wire [23:0] R_D00; 
wire [23:0] R_D01;
wire [23:0] R_D02;
wire [23:0] R_D03;
wire [23:0] R_D04;
wire [23:0] R_D05;
wire [23:0] R_D06;
wire [23:0] R_D07;
wire [23:0] R_D08;
wire [23:0] R_D09;
wire [23:0] R_D10;
wire [23:0] R_D11;
wire [23:0] R_D12;
wire        SPI_SYS_CLK ; 
//===================


always @(posedge OSC_50) 	TIME<=TIME+1;

assign SPI_SYS_CLK  =TIME[5]   ; 


 
assign  R_D00 = { 3'b000, 13'h014 , 8'h01 } ;//2'S
assign  R_D01 = { 3'b100, 13'h002 , 8'h00 } ;//read Grade 55H
assign  R_D02 = { 3'b100, 13'h001 , 8'h00 } ;//read ID 88H
assign  R_D03 = { 3'b000, 13'h018 , 8'h04 } ;//Internal VREF digital adjustment 2Vp-p
assign  R_D04 = { 3'b000, 13'h010 , 8'h00 } ;//offset
assign  R_D05 = { 3'b000, 13'h100 , 8'h00 } ;//sample rate override 14bit  125mps
assign  R_D06 = { 3'b000, 13'h0ff , 8'h01 } ;//Transfer 
assign  R_D07 = { 3'b000, 13'h102 , 8'h00 } ; // 0x08 vcm power  down
assign  R_D08 = { 3'b000, 13'h0ff , 8'h01 } ;//Transfer 
assign  R_D09 = { 3'b000, 13'h0ff , 8'h00 } ;//Transfer 
assign  R_D10 = { 3'b000, 13'h014 , 8'h01 } ;//2'S
assign  R_D11 = { 3'b000, 13'h03A , 8'h02 } ; //SYNCE



 SPI_CTRL_J 	spi1 (
	.oDIN    ( ADC1_SDIO_DCS  ),
	.oCS_n   ( ADC1_CSB       ), 
	.oSCLK   ( ADC1_SCLK_DFS  ),
	.iCLK    ( SPI_SYS_CLK ),
	.RESET_N ( RESET_N )  ,   
	.iR_D00  ( R_D00 ), 
	.iR_D01  ( R_D01 ), 
	.iR_D02  ( R_D02 ), 
	.iR_D03  ( R_D03 ),	
	.iR_D04  ( R_D04 ),		
	.iR_D05  ( R_D05 ),		
	.iR_D06  ( R_D06 ),	
	.iR_D07  ( R_D07 ),		
	.iR_D08  ( R_D08 ),		
	.iR_D09  ( R_D09 ),		
	.iR_D10  ( R_D10 ),		
	.iR_D11  ( R_D11 ),		
	.iR_D12  ( R_D12 ),		
	
	.CHIP_ID  ( CHIP_ID1   ) , 
	.CHIP_RADE( CHIP_RADE1 ),
	.READY   (READY1)
				);
//--

 SPI_CTRL_J 	spi2 (
	.oDIN    ( ADC2_SDIO_DCS  ),
	.oCS_n   ( ADC2_CSB       ), 
	.oSCLK   ( ADC2_SCLK_DFS  ),
	.iCLK    ( SPI_SYS_CLK ),
	.RESET_N ( RESET_N )  , 
	.iR_D00  ( R_D00 ), 
	.iR_D01  ( R_D01 ), 
	.iR_D02  ( R_D02 ), 
	.iR_D03  ( R_D03 ),	
	.iR_D04  ( R_D04 ),		
	.iR_D05  ( R_D05 ),		
	.iR_D06  ( R_D06 ),	
	.iR_D07  ( R_D07 ),		
	.iR_D08  ( R_D08 ),
	.iR_D09  ( R_D09 ),		
	.iR_D10  ( R_D10 ),		
	.iR_D11  ( R_D11 ),		
	.iR_D12  ( R_D12 ),			
   .CHIP_ID	(CHIP_ID2) ,
   .CHIP_RADE (CHIP_RADE2) , 
	.READY   ( READY2 ) 
				);	
				
endmodule 				
				