

	// xcvrs x8 10G - 10G for ST, 6G for SXT
	//`define	fmc_xcvr_10G     
	//`define	fmc_xcvr_clock_cleaner	
	// xcvrs x2 6G
	//`define	fmcb_xcvr_6G 
	// xcvrs x2 10G
	//`define	fmcb_xcvr_10G                                         	
	// Comment in the LVDS assignment and terminations for fmc_la signals in the assignment editor
	//`define	fmc_lvds   
	// fmc_parallel and fmc_lvds are mutually exclusive, they use the same fmc_la pins
	//`define	fmc_parallel  
	// Comment in the LVDS assignment and terminations for fmc_la signals in the assignment editor
	//`define	fmcb_lvds   
	// fmcb_parallel and fmcb_lvds are mutually exclusive, they use the same fmc_la pins
	//`define	fmcb_parallel
	//`define	pcie_xcvr
	//`define	sma_xcvr
	//`define	sfpa_xcvr
	//`define	sfpb_xcvr  


module golden_top
(
//--------------------------------------------------------------------------//
  
//-----------cpu_-----------
	input			cpu_resetn,

//-----------user_pb_fpga-----------
	input	[3:0]	user_pb_fpga, 

//-----------user_dipsw_fpga-----------
	input	[3:0]	user_dipsw_fpga, 

//-----------user_led_fp-----------
	output	[3:0]	user_led_fpga,   


//-----------fmc-----------  
inout Si5340B_I2C_SDA,
inout Si5340B_I2C_SCL,
input Si5340B_INTR,
output Si5340B_RST_n,
output Si5340B_OE_n,

input [13:0] ADC_A_D , 
input [13:0] ADC_B_D , 
input ADC_A_ORA,
input ADC_B_ORB,
input ADC_A_DCOA,
input ADC_B_DCOB ,

output ADC1_PDWN,
inout ADC1_SDIO_DCS,
output [1:0]ADC1_CK_S,
output ADC1_SCLK_DFS,
output ADC1_CSB,
output ADC1_OEB,
output ADC1_SYNC,
output FPGA_CLK_ADC1_p,
//output FPGA_CLK_ADC1_n,

// FMC main
`ifdef	fmc_xcvr_10G       
	//output	[7:0]	fmc_dp_c2m_n, 
	output	[7:0]	fmc_dp_c2m_p, 
	//input	[7:0]	fmc_dp_m2c_n, 
	input	[7:0]	fmc_dp_m2c_p, 
`endif  

	//input	[1:0]	fmc_clk_m2c_n,     
	input	[1:0]	fmc_clk_m2c_p, 
	inout	[1:0]	fmc_ga, 
`ifdef	use_fmc_gbtclk_m2c_p_0
	//input		fmc_gbtclk_m2c_n_0, 
	input		fmc_gbtclk_m2c_p_0, 
`endif   
`ifdef	use_fmc_gbtclk_m2c_p_1
	//input		fmc_gbtclk_m2c_n_1, 
	input		fmc_gbtclk_m2c_p_1, 
`endif   
	//inout	[7:0]	fmc_gpio,
	// Use fmc_gpio as differential pairs
	// fmc and fmcb la pins remapped to simplify tests by allowing buses 
	// fmc  and fmcb la tx/rx p/n 8 and 11 used for the clock cleaner
	// To map for this test removed 8 and 11 then renumbered bus for lvds and parallel testing only
	`ifdef	fmc_lvds 
	// fmcb_gpio_1,3,5,7 are the "N" side of LVDS
	input		fmc_gpio_0,
	input		fmc_gpio_2,
	output		fmc_gpio_4,
	input		fmc_gpio_6,
	//input		fmc_la_rx_clk_n,
	input		fmc_la_rx_clk_p,
	//input	[15:0]	fmc_la_rx_n, 
	input	[15:0]	fmc_la_rx_p, 
	//output	fmc_la_tx_clk_n,
	output		fmc_la_tx_clk_p,
	//output	[17:0]	fmc_la_tx_n, 
	output		[17:0]	fmc_la_tx_p, 
`endif
`ifdef	fmc_parallel
	inout		fmc_la_rx_clk_n,
	inout		fmc_la_rx_clk_p,
	inout	[15:0]	fmc_la_rx_n, 
	inout	[15:0]	fmc_la_rx_p, 
	inout		fmc_la_tx_clk_n,
	inout		fmc_la_tx_clk_p,
	inout	[17:0]	fmc_la_tx_n, 
	inout	[17:0]	fmc_la_tx_p, 
`endif

	input		fmc_prsntn,
	inout		fmc_scl,
	inout		fmc_sda,   

// FMC B
`ifdef	fmcb_xcvr_6G        
	output		fmcb_dp_c2m_p_0,
	output		fmcb_dp_c2m_p_1, 
	input		fmcb_dp_m2c_p_0, 
	input		fmcb_dp_m2c_p_1, 
`endif          

`ifdef	fmcb_xcvr_10G        
	output		fmcb_dp_c2m_p_2,
	output		fmcb_dp_c2m_p_3, 
	input		fmcb_dp_m2c_p_2, 
	input		fmcb_dp_m2c_p_3,
`endif
	//input	[1:0]	fmcb_clk_m2c_n,     
	input	[1:0]	fmcb_clk_m2c_p, 
	inout	[1:0]	fmcb_ga,  
	
`ifdef	use_fmcb_gbtclk_m2c_p_0
	//input		fmcb_gbtclk_m2c_n_0, 
	input		fmcb_gbtclk_m2c_p_0, 
`endif   
`ifdef	use_fmcb_gbtclk_m2c_p_1
	//input		fmcb_gbtclk_m2c_n_1, 
	input		fmc_gbtclk_m2c_p_1, 
`endif                  
	//inout	[7:0]	fmc_gpio,
	// Use fmcb_gpio as differential pairs
`ifdef	fmcb_lvds             
	// fmcb_gpio_1,3,5,7 are the "N" side of LVDS
	output		fmcb_gpio_0,
	input		fmcb_gpio_2,
	input		fmcb_gpio_4,      // fmc this is TX, fmcb this is RX
	input		fmcb_gpio_6,
	//input		fmcb_la_rx_clk_n,
	input		fmcb_la_rx_clk_p,
	//input	[15:0]	fmcb_la_rx_n, 
	input	[15:0]	fmcb_la_rx_p, 
	//output	fmcb_la_tx_clk_n,
	output		fmcb_la_tx_clk_p,
	//output	[17:0]	fmcb_la_tx_n, 
	output		[17:0]	fmcb_la_tx_p, 
`endif                  
`ifdef	fmcb_parallel   
	inout		fmcb_la_rx_clk_n,
	inout		fmcb_la_rx_clk_p,
	inout	[15:0]	fmcb_la_rx_n, 
	inout	[15:0]	fmcb_la_rx_p, 
	inout		fmcb_la_tx_clk_n,
	inout		fmcb_la_tx_clk_p,
	inout	[17:0]	fmcb_la_tx_n, 
	inout	[17:0]	fmcb_la_tx_p, 
`endif                  
                        
	input		fmcb_prsntn,
	inout		fmcb_scl,
	inout		fmcb_sda,   
	
//-----------pcie-----------
//---Found multiple nets with the same name    
 `ifdef	pcie_xcvr
	//input	[3:0]	pcie_rx_n, 
	input	[3:0]	pcie_rx_p, 
	//output[3:0]	pcie_tx_n, 
	output	[3:0]	pcie_tx_p, 
`endif 
`ifdef	use_pcie_refclk_qr0_p
  	//input		pcie_refclk_qr0_n,
	input		pcie_refclk_qr0_p,  
`endif                  
	output		pcie_perstn_out,	// Pin AH21 instance 0 
	input		pcie_perstn_in,		// Pin AK6 instance 1 
	inout		pcie_prsnt2_x1, 
	inout		pcie_prsnt2_x4, 
                        
                        
	inout		pcie_smbclk,
	inout		pcie_smbdat,
                        
	inout		pcie_waken,

//-----------sma-----------    
`ifdef	sma_xcvr
	input		   sma_clkin,
	input		   sma_xcvr_rx_n,
	input		   sma_xcvr_rx_p,
	output	   sma_xcvr_tx_n,
	output		sma_xcvr_tx_p,  
`endif

//-----------sfp-----------      
  `ifdef	sfpa_xcvr
	//input		sfpa_rx_n,
	input		  sfpa_rx_p,
	//input		sfpa_tx_n,
	output		sfpa_tx_p, 
`endif                  
	input		sfpa_los,
	input		sfpa_mod0_prsntn,
	output		sfpa_mod1_scl,
	output		sfpa_mod2_sda,
	output	[1:0]	sfpa_ratesel,     
	output		sfpa_txdisable,
	input		sfpa_txfault,  
`ifdef	sfpb_xcvr       
	//input		sfpb_rx_n,
	input		sfpb_rx_p,
	output	   sfpb_tx_n,
	output		sfpb_tx_p,  
`endif  	        
	input		sfpb_los,
	input		  sfpb_mod0_prsntn,
	output		sfpb_mod1_scl,
	output		sfpb_mod2_sda,                        
	output	[1:0]	sfpb_ratesel, 
	output		sfpb_txdisable,                                                 
	input		sfpb_txfault,
                  
`ifdef	use_refclk_qr2_p
//-----------ref-----------
	//input		refclk_qr2_n,
	input		refclk_qr2_p,
`endif    
                             
	//input		lmk_clean_clk_n,
	input		lmk_clean_clk_p,
`ifdef	use_lmk_fmcclk_p
	//input		lmk_fmcclk_n,
	input		lmk_fmcclk_p,	
`endif
	input		lmk_reset,
`ifdef	use_lmk_sfpclk_p
	//input		lmk_sfpclk_n,
	input		lmk_sfpclk_p,
`endif
	//input		lmk_sysref_n,
	input		lmk_sysref_p,	                                                           
  	//output	rclock_out_n,
	output		rclock_out_p,  
	
//-----------usb-----------      
//inout		usb_b2_clk,
//inout	[7:0]	usb_b2_data, 
//inout		usb_empty,
//inout	[7:0]	usb_fpga_data, 
//inout		usb_fpga_rdn,
//inout		usb_fpga_rxfn,
//inout		usb_fpga_txen,
//inout		usb_fpga_wr,
//inout		usb_full,
//inout		usb_oen,
//inout		usb_rdn,
//inout		usb_resetn,
//inout		usb_scl,
//inout		usb_sda,
//inout		usb_wrn, 

//-----------clk-----------
	input		clk_100m_fpga,
`ifdef	use_clk_148_p
	//input		clk_148_n,
	input		clk_148_p,
`endif                  
	input		clk_50m_fpga,
	input		clk_bot1,
	//input		clk_enet_fpga_n,
	input		clk_enet_fpga_p,
	input		clk_enet_fpga_phy,
	input		clk_top1,

//-----------sdi-----------
	output		sdi_clk148_dn,
	output		sdi_clk148_up 

);


//=======================================================
//  REG/WIRE declarations
//=======================================================
wire        PDWN; 
wire [7:0 ] CHIP_ID1;
wire [7:0 ] CHIP_ID2; 
wire        READY1;
wire        READY2;
wire        SP_CLK;
wire [7:0]  HZ; 
wire        M50_1HZ; 
wire        CLK_400M ; 
wire [35:0] FREQ_OSC_50_B4D;    
wire [35:0] FREQ_ADC_A_DCOA;  
wire [35:0] FREQ_ADC_B_DCOB;
wire [35:0] FREQ_ADC_C_DCOC;
wire [35:0] FREQ_ADC_D_DCOD;
wire [35:0] FREQ_FPGA_CLK_ADC1_p;
wire [35:0] FREQ_FPGA_CLK_ADC2_p;
wire        CLOCK_LOCK ; 

//=======================================================
//  Structural coding
//=======================================================


//-- Si5340B release 
assign Si5340B_I2C_SDA =1'bz;
assign Si5340B_I2C_SCL =1'bz;	
assign Si5340B_RST_n   =1'b1;
assign Si5340B_OE_n    =1'b0;	


//--ADC CHIP Control---
assign  PDWN  = ~user_pb_fpga[1] ; 

//---ADC Clock Slection , 
//00: Si5340 Clock  
//01: SMA  Clock
//10: FPGA Clock 
assign ADC1_CK_S[1:0] =user_dipsw_fpga[1:0] ; 
//assign ADC2_CK_S[1:0] =user_dipsw_fpga[1:0] ; 

//--ADC Control
assign  ADC1_PDWN = PDWN  ; //1: POWER DOWN  , 0: 1: NO POWER DOWN  
assign  ADC1_SYNC = 1;
assign  ADC1_OEB  =~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
//assign  ADC2_PDWN =PDWN  ; //1: POWER DOWN  , 0: 1: NO POWER DOWN
//assign  ADC2_SYNC =1;
//assign  ADC2_OEB  =0;      //OEB pin is low, the output data drivers and DCOs are enabled. 
 

//--SPI WRITE/READ 
// 1) read ADC IC (AD9648) ID(0x01) /GRADE(0x02) , 
// 2) set Output mode (0x14) , set to twos complement
// 3) set Power mode (0x08) digital reset/ normal operation . (Clock Stability Considerations see data sheet page40 ) 
SPI_SET_2CH  rt(
    .OSC_50        (clk_50m_fpga   ), 
    .RESET_N       (user_pb_fpga[0]), 
    .ADC1_SDIO_DCS (ADC1_SDIO_DCS  ),
    .ADC1_CSB      (ADC1_CSB       ),
    .ADC1_SCLK_DFS (ADC1_SCLK_DFS  ),
    .CHIP_ID1      (CHIP_ID1       ),
	 .READY1        (READY1         ) , // 1: ADC1 SPI write/read ready 
);				
								
//--LED Display 						 
assign user_led_fpga  =(CHIP_ID1==8'h88) ?  HZ[3:0]   :4'h0  ; 


//--FPGA CLOCK Generater

PLL125 pl1( 
	.refclk  (clk_50m_fpga    ),
	.rst     (~user_pb_fpga[1]),
	.outclk_0(FPGA_CLK_ADC1_p ),
	.locked  (CLOCK_LOCK      )   
) ; 
	
	
//--SMA 	CLOCK output
assign rclock_out_p	  = FPGA_CLK_ADC1_p ; 

		
//--4CH ADC DATA FIFO 	
FIFO da( .aclr(~CLOCK_LOCK),.data (ADC_A_D), .wrclk(ADC_A_DCOA),.rdclk(SP_CLK), .q());
FIFO db( .aclr(~CLOCK_LOCK),.data (ADC_B_D), .wrclk(ADC_B_DCOB),.rdclk(SP_CLK), .q());

assign  SP_CLK = ADC_A_DCOA ;
  
//-------1HZ heart genearter  
CLOCKMEM k0(  .RESET_n(user_pb_fpga[0]), .CLK(clk_50m_fpga     ),.CLK_FREQ (50000000),  .CK_1HZ(HZ[0]) ) ;  
CLOCKMEM k00( .RESET_n(user_pb_fpga[0]), .CLK(ADC_A_DCOA      ),.CLK_FREQ  (125000000), .CK_1HZ(HZ[1]) ) ; 
CLOCKMEM k1(  .RESET_n(user_pb_fpga[0]), .CLK(ADC_B_DCOB      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[2]) ) ; 
CLOCKMEM k5(  .RESET_n(user_pb_fpga[0]), .CLK(FPGA_CLK_ADC1_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[3]) ) ; 


//---------------FREQ TEST -------------------
CLOCKMEM  ck2( .RESET_n(user_pb_fpga[0]), .CLK(clk_50m_fpga ) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;
FRE_MEASURE mes1 ( .RESET_n(user_pb_fpga[0]),.MES_CLK (clk_50m_fpga      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_OSC_50_B4D     ) ); 
FRE_MEASURE mes4 ( .RESET_n(user_pb_fpga[0]),.MES_CLK (ADC_A_DCOA      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_A_DCOA     ) ); 
FRE_MEASURE mes6 ( .RESET_n(user_pb_fpga[0]),.MES_CLK (ADC_B_DCOB      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_B_DCOB     ) ); 
FRE_MEASURE mes12( .RESET_n(user_pb_fpga[0]),.MES_CLK (FPGA_CLK_ADC1_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC1_p) );
PLL400  TT(
	.rst      (~user_pb_fpga[1]),
	.refclk   (clk_50m_fpga),
	.locked   (),
	.outclk_0 (CLK_400M) );			  
TP t(
    .SP_CLK              ( SP_CLK )  ,
    .CLK                 ( CLK_400M           ),
    .TR                  ( M50_1HZ            ), 
	 .ADC1_CK_S           ( ADC1_CK_S[1:0]     ),
    .FREQ_OSC_50_B4D     (FREQ_OSC_50_B4D     ), 
    .FREQ_ADC_A_DCOA     (FREQ_ADC_A_DCOA     ), 
    .FREQ_ADC_B_DCOB     (FREQ_ADC_B_DCOB     ),
    .FREQ_FPGA_CLK_ADC1_p(FREQ_FPGA_CLK_ADC1_p )
	 ) ;  
	      
endmodule
