
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module HAN_ADC_FMC(

	//////////// CLOCK //////////
	input 		          		CLKUSR_100,
	input 		          		CLK_50_B2A,
	input 		          		CLK_50_B2H,
	input 		          		CLK_50_B3F,
	input 		          		CLK_50_B3H,

	//////////// KEY //////////
	input 		          		CPU_RESET_n,
	input 		     [1:0]		KEY,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED //////////
	output		     [1:0]		LED,

	//////////// SEG7 //////////
	output		          		HEX0_DP,
	output		     [6:0]		HEX0_D,
	output		          		HEX1_DP,
	output		     [6:0]		HEX1_D,

	//////////// Clock Generator Configure //////////
	inout 		          		CDCM6208_SCL,
	inout 		          		CDCM6208_SDA,

	//////////// FMC, FMC connect to ADC-FMC //////////
	output		     [1:0]		ADC1_CK_S,
	output		          		ADC1_CSB,
	output		          		ADC1_OEB,
	output		          		ADC1_PDWN,
	output		          		ADC1_SCLK_DFS,
	inout 		          		ADC1_SDIO_DCS,
	output		          		ADC1_SYNC,
	output		     [1:0]		ADC2_CK_S,
	output		          		ADC2_CSB,
	output		          		ADC2_OEB,
	output		          		ADC2_PDWN,
	output		          		ADC2_SCLK_DFS,
	inout 		          		ADC2_SDIO_DCS,
	output		          		ADC2_SYNC,
	input 		          		ADC_A_DCOA,
	input 		    [13:0]		ADC_A_D,
	input 		          		ADC_A_ORA,
	input 		          		ADC_B_DCOB,
	input 		    [13:0]		ADC_B_D,
	input 		          		ADC_B_ORB,
	input 		          		ADC_C_DCOC,
	input 		    [13:0]		ADC_C_D,
	input 		          		ADC_C_ORC,
	input 		          		ADC_D_DCOD,
	input 		    [13:0]		ADC_D_D,
	input 		          		ADC_D_ORD,
	output		          		FPGA_CLK_ADC1_p,
	output		          		FPGA_CLK_ADC2_p,
	inout 		          		SI5340B_I2C_SCL,
	inout 		          		SI5340B_I2C_SDA,
	input 		          		SI5340B_INTR,
	output		          		SI5340B_OE_n,
	output		          		SI5340B_RST_n,
	//////////// SMA //////////
	input 		          		SMA_CLKIN_p,
	output		          		SMA_CLKOUT_p
	

);




//=======================================================
//  REG/WIRE declarations
//=======================================================
wire        PDWN; 
wire [7:0 ] CHIP_ID1;
wire [7:0 ] CHIP_ID2; 
wire        READY1;
wire        READY2;
wire        SP_CLK;
wire [7:0]  HZ; 
wire        M50_1HZ; 
wire        CLK_400M ; 
wire [35:0] FREQ_CLK_50_B2H;    
wire [35:0] FREQ_ADC_A_DCOA;  
wire [35:0] FREQ_ADC_B_DCOB;
wire [35:0] FREQ_ADC_C_DCOC;
wire [35:0] FREQ_ADC_D_DCOD;
wire [35:0] FREQ_FPGA_CLK_ADC1_p;
wire [35:0] FREQ_FPGA_CLK_ADC2_p;
wire        CLOCK_LOCK ; 

//=======================================================
//  Structural coding
//=======================================================


//-- Si5340B release 
assign SI5340B_I2C_SDA =1'bz;
assign SI5340B_I2C_SCL =1'bz;	
assign SI5340B_RST_n   =1'b1;
assign SI5340B_OE_n    =1'b0;	


//--ADC CHIP Control---
assign  PDWN  = ~KEY[1] ; 

//---ADC Clock Slection , 
//00: Si5340 
//01: SMA  CLOCK 
//10: FPGA CLOCK 
assign ADC1_CK_S[1:0] =SW[1:0] ; 
assign ADC2_CK_S[1:0] =SW[1:0] ; 

//--ADC Control
assign  ADC1_PDWN =PDWN  ;           //1: POWER DOWN  , 0: 1: NO POWER DOWN  
assign  ADC1_SYNC =1;
assign  ADC1_OEB  =~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
assign  ADC2_PDWN =PDWN  ;           //1: POWER DOWN  , 0: 1: NO POWER DOWN
assign  ADC2_SYNC =1;
assign  ADC2_OEB  =~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
 

//--SPI WRITE/READ 
// 1) read ADC IC (AD9648) ID(0x01) /GRADE(0x02) , 
// 2) set Output mode (0x14) , set to  twos complement
// 3) set Power mode (0x08) digital reset/ normal operation . (Clock Stability Considerations see data sheet page40 ) 
SPI_SET_2CH  rt(
    .OSC_50        (CLK_50_B2H), 
    .RESET_N        (KEY[0]    ), 
    .ADC1_SDIO_DCS (ADC1_SDIO_DCS ),
    .ADC1_CSB      (ADC1_CSB      ),
    .ADC1_SCLK_DFS (ADC1_SCLK_DFS ),
    .ADC2_SDIO_DCS (ADC2_SDIO_DCS),
    .ADC2_CSB      (ADC2_CSB     ),
    .ADC2_SCLK_DFS (ADC2_SCLK_DFS),
    .CHIP_ID1      (CHIP_ID1),
    .CHIP_ID2      (CHIP_ID2),
	 .READY1        (READY1) , // 1: ADC1 SPI write/read ready 
	 .READY2        (READY2)   // 1: ADC1 SPI write/read ready  
);				
								
//--LED Display 						 
assign { HEX1_DP , HEX0_DP , LED }= ((CHIP_ID1==8'h88) && ( CHIP_ID2==8'h88 )) ?  HZ[4:1] :4'hF  ;
//--7-seg disable 
assign HEX0_D =7'h7f ;
assign HEX1_D =7'h7f ;

//--FPGA CLOCK Generater
PLL125 pl1( 
	.refclk  (CLK_50_B2H),
	.rst     (~CPU_RESET_n),
	.outclk_0(FPGA_CLK_ADC1_p),
	.outclk_1(FPGA_CLK_ADC2_p),
	.locked  (CLOCK_LOCK) ) ; 
	
	
//--SMA 	CLOCK output
assign SMA_CLKOUT_p	  = FPGA_CLK_ADC1_p ; 
//assign SMA_CLKOUT_n    = FPGA_CLK_ADC2_p ; 
	
	
//--4CH ADC DATA FIFO 	
FIFO da( .aclr(~CLOCK_LOCK),.data (ADC_A_D), .wrclk(ADC_A_DCOA),.rdclk(SP_CLK),.q());
FIFO db( .aclr(~CLOCK_LOCK),.data (ADC_B_D), .wrclk(ADC_B_DCOB),.rdclk(SP_CLK),.q());
FIFO dc( .aclr(~CLOCK_LOCK),.data (ADC_C_D), .wrclk(ADC_C_DCOC),.rdclk(SP_CLK),.q());
FIFO dd( .aclr(~CLOCK_LOCK),.data (ADC_D_D), .wrclk(ADC_D_DCOD),.rdclk(SP_CLK),.q());




assign  SP_CLK = ADC_A_DCOA ;
  
//-------1HZ heart genearter  
CLOCKMEM k0(  .RESET_n(KEY[1]), .CLK(CLK_50_B2H      ),.CLK_FREQ  (50000000),  .CK_1HZ(HZ[0]) ) ;  
CLOCKMEM k00( .RESET_n(KEY[1]), .CLK(ADC_A_DCOA      ),.CLK_FREQ  (125000000), .CK_1HZ(HZ[1]) ) ; 
CLOCKMEM k1(  .RESET_n(KEY[1]), .CLK(ADC_B_DCOB      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[2]) ) ; 
CLOCKMEM k3(  .RESET_n(KEY[1]), .CLK(ADC_C_DCOC      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[3]) ) ; 
CLOCKMEM k4(  .RESET_n(KEY[1]), .CLK(ADC_D_DCOD      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[4]) ) ; 
CLOCKMEM k5(  .RESET_n(KEY[1]), .CLK(FPGA_CLK_ADC1_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[5]) ) ; 
CLOCKMEM k6(  .RESET_n(KEY[1]), .CLK(FPGA_CLK_ADC2_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[6]) ) ; 
CLOCKMEM k7(  .RESET_n(KEY[1]), .CLK(SMA_CLKIN_p     ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[7]) ) ; 


//---------------FREQ TEST -------------------
CLOCKMEM  ck2  (   .RESET_n(KEY[0]),.CLK     (CLK_50_B2H      ) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;
FRE_MEASURE mes1 ( .RESET_n(KEY[0]),.MES_CLK (CLK_50_B3H      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_CLK_50_B2H     ) ); 
FRE_MEASURE mes4 ( .RESET_n(KEY[0]),.MES_CLK (ADC_A_DCOA      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_A_DCOA     ) ); 
FRE_MEASURE mes6 ( .RESET_n(KEY[0]),.MES_CLK (ADC_B_DCOB      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_B_DCOB     ) ); 
FRE_MEASURE mes3 ( .RESET_n(KEY[0]),.MES_CLK (ADC_C_DCOC      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_C_DCOC     ) ); 
FRE_MEASURE mes7 ( .RESET_n(KEY[0]),.MES_CLK (ADC_D_DCOD      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_D_DCOD     ) ); 
FRE_MEASURE mes12( .RESET_n(KEY[0]),.MES_CLK (FPGA_CLK_ADC1_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC1_p) );
FRE_MEASURE mes13( .RESET_n(KEY[0]),.MES_CLK (FPGA_CLK_ADC2_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC2_p) ); 																																
PLL400  TT(
	.rst      (~CPU_RESET_n),
	.refclk   (CLK_50_B3H),
	.locked   (),
	.outclk_0 (CLK_400M) );			  
TP t(
    .SP_CLK              ( SP_CLK )  ,
    .CLK                 ( CLK_400M           ),
    .TR                  ( M50_1HZ            ), 
	 .ADC1_CK_S           ( ADC1_CK_S[1:0]     ),
	 .ADC2_CK_S           ( ADC2_CK_S[1:0]     ),
    .FREQ_OSC_50_B4D     (FREQ_CLK_50_B2H     ), 
    .FREQ_ADC_A_DCOA     (FREQ_ADC_A_DCOA     ), 
    .FREQ_ADC_B_DCOB     (FREQ_ADC_B_DCOB     ),
    .FREQ_ADC_C_DCOC     (FREQ_ADC_C_DCOC     ),
    .FREQ_ADC_D_DCOD     (FREQ_ADC_D_DCOD     ) ,
    .FREQ_FPGA_CLK_ADC1_p(FREQ_FPGA_CLK_ADC1_p ),
	 .FREQ_FPGA_CLK_ADC2_p(FREQ_FPGA_CLK_ADC2_p )
	 ) ;  
	      
endmodule

