module SPI_CTRL_J 	(	
input              RESET_N , 
input				    iCLK,
input	       [23:0]iCREG,
input	       [23:0]iR_D12,
input	       [23:0]iR_D11,
input	       [23:0]iR_D10,
input	       [23:0]iR_D09,
input	       [23:0]iR_D08,
input	       [23:0]iR_D07,
input	       [23:0]iR_D06,
input	       [23:0]iR_D05,
input	       [23:0]iR_D04,
input	       [23:0]iR_D03,
input	       [23:0]iR_D02,
input	       [23:0]iR_D01,
input	       [23:0]iR_D00,
output	reg [23:0]oSPI_D, 

inout 	reg	   oDIN,
output	reg 	   oCS_n,
output	reg	   oSCLK,
input				   iDOUT,
output	reg	   REG_CK,
output	reg	   [4:0] REG_ADDRESS ,
output	reg[7:0]	  CHIP_RADE,
output	reg[7:0]	  CHIP_ID  ,
//--test 
output reg [7:0]  ST,
output reg [15:0] COUNTER , 
output reg [15:0] DEV_NUN,
output reg        READ_VAILD,
output reg        DEV_CK , 
output  TR,  
output  reg [8:0]RDATA , 
output  reg [8:0]RD,
output reg       WR ,
output reg [12:0]REGI ,
output reg READY 

				);
					
parameter  DEIVE          = 12;//12 ;  
				 
reg [23:0] CREG ;
reg [23:0] SPI_DATA;
reg [31:0] DELAY ;   

	

always@( negedge RESET_N or posedge iCLK )
   if ( !RESET_N) begin 
	   ST <=0; 
		DEV_NUN <=0 ; //12
		oCS_n   <=1; 
		oSCLK   <=0;
		oDIN    <=0;  
		READ_VAILD <=0; 
		READY   <=0;
	end 
else 
begin
case (ST)
0:begin 
      READY   <=0;
      DEV_CK  <=  1 ; 
      ST     <=1;
		oSCLK  <=0;
		COUNTER<=24;
		RDATA  <=0;
		     if  (DEV_NUN ==0)   {WR ,REGI,CREG  } <= {iR_D00[23],iR_D00[20:8],iR_D00[23:0]} ;
		else if  (DEV_NUN ==1)   {WR ,REGI,CREG  } <= {iR_D01[23],iR_D01[20:8],iR_D01[23:0]} ;
		else if  (DEV_NUN ==2)   {WR ,REGI,CREG  } <= {iR_D02[23],iR_D02[20:8],iR_D02[23:0]} ;
		else if  (DEV_NUN ==3)   {WR ,REGI,CREG  } <= {iR_D03[23],iR_D03[20:8],iR_D03[23:0]} ;
		else if  (DEV_NUN ==4)   {WR ,REGI,CREG  } <= {iR_D04[23],iR_D04[20:8],iR_D04[23:0]} ;
		else if  (DEV_NUN ==5)   {WR ,REGI,CREG  } <= {iR_D05[23],iR_D05[20:8],iR_D05[23:0]} ;
		else if  (DEV_NUN ==6)   {WR ,REGI,CREG  } <= {iR_D06[23],iR_D06[20:8],iR_D06[23:0]} ;
		else if  (DEV_NUN ==7)   {WR ,REGI,CREG  } <= {iR_D07[23],iR_D07[20:8],iR_D07[23:0]} ;
		else if  (DEV_NUN ==8)   {WR ,REGI,CREG  } <= {iR_D08[23],iR_D08[20:8],iR_D08[23:0]} ;
		else if  (DEV_NUN ==9)   {WR ,REGI,CREG  } <= {iR_D09[23],iR_D09[20:8],iR_D09[23:0]} ;
		else if  (DEV_NUN ==10)  {WR ,REGI,CREG  } <= {iR_D10[23],iR_D10[20:8],iR_D10[23:0]} ;
		else if  (DEV_NUN ==11)  {WR ,REGI,CREG  } <= {iR_D11[23],iR_D11[20:8],iR_D11[23:0]} ;
		else if  (DEV_NUN ==12)  {WR ,REGI,CREG  } <= {iR_D12[23],iR_D12[20:8],iR_D12[23:0]} ;

		{ oSPI_D[23:0] , SPI_DATA[23:0] } <= { SPI_DATA[23:0] ,23'h0};
  end 
1:begin 
       oCS_n  <= 0; 
       ST<=2;
  end 
2:begin 
         if ( ( WR ) && ( COUNTER <= 8) )  oDIN <= 1'bz ; 
		   else   {oDIN,CREG[23:0]} <= {CREG[23:0], 1'b0} ;
              ST    <=3;
				  DELAY <=0;       
         end 
3:begin 
      if  ( DELAY ==5 )   begin     
		     oSCLK  <=1;
		   if ( ( WR ) && ( COUNTER <= 8) )  RDATA[8:0]  <= {RDATA[7:0], oDIN} ;
           COUNTER<=COUNTER-1;
           ST<=4;
			  DELAY <= 0; 
		 end  	  
		 else  DELAY <=DELAY+1; 
  end 
4:begin 
      if  ( DELAY ==5 )   begin  
        oSCLK  <=0;
        if    ( COUNTER!=0)  ST<=10 ; 
        else  begin 
		    ST<=5; 
			 oCS_n   <=1;
		  end 
		end 
		 else  DELAY <=DELAY+1; 
  end 
5:begin 
        if ( REGI[12:0] ==13'h02) CHIP_RADE <= RDATA[7:0]; //read Chip grade: 100 (105 MSPS) , 101 (125 MSPS)
        if ( REGI[12:0] ==13'h01) CHIP_ID   <= RDATA[7:0]; //read chip id ( AD9648 = 0x88 ) 

		  DEV_NUN  <=DEV_NUN  +1 ; 		    
        ST<=6 ;		  
		  DELAY <=0;       
end
6: begin
         if  ( DELAY ==5 )   begin  
			   if ( DEV_NUN ==DEIVE ) ST<=7;
			   else ST<=0; //END
			end 
			else  DELAY <=DELAY+1; 
	end		
		    
7: begin
			ST      <= 20;  
			READY   <= 1 ; 
        	DELAY   <= 0;       
		   DEV_NUN <= 0 ;			  
   end  
 	
//---read shifter 

10: begin 
	  SPI_DATA[23:0] <= {SPI_DATA[22:0], iDOUT} ; 
	  ST<=2;  	  
end 	   
	
//--END 
20: begin 
	   ST<=20;
end 	   
	
endcase
end

endmodule
