
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module S10_ADC_FMC(

	//////////// CLOCK //////////
	input 		          		CLK_100_B3I,
	input 		          		CLK_50_B2F,
	input 		          		CLK_50_B2L,
	input 		          		CLK_50_B3C,
	input 		          		CLK_50_B3I,
	input 		          		LVDS_REFCLK_p,

	//////////// BUTTON //////////
	input 		     [1:0]		BUTTON,
	input 		          		CPU_RESET_n,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED //////////
	output		     [1:0]		LED,

	//////////// SI5341A Configure //////////
	inout 		          		SI5341A_I2C_SCL,
	inout 		          		SI5341A_I2C_SDA,
	output		          		SI5341A_OE_n,
	output		          		SI5341A_RST_n,

	//////////// FMC Transceiver Reference Clocks //////////
	input 		          		FMC_REFCLK0_p,
	input 		          		FMC_REFCLK1_p,

	//////////// FMC, FMC connect to ADC-FMC //////////
	output		     [1:0]		ADC1_CK_S,
	output		          		ADC1_CSB,
	output		          		ADC1_OEB,
	output		          		ADC1_PDWN,
	output		          		ADC1_SCLK_DFS,
	inout 		          		ADC1_SDIO_DCS,
	output		          		ADC1_SYNC,
	output		     [1:0]		ADC2_CK_S,
	output		          		ADC2_CSB,
	output		          		ADC2_OEB,
	output		          		ADC2_PDWN,
	output		          		ADC2_SCLK_DFS,
	inout 		          		ADC2_SDIO_DCS,
	output		          		ADC2_SYNC,
	input 		          		ADC_A_DCOA,
	input 		    [13:0]		ADC_A_D,
	input 		          		ADC_A_ORA,
	input 		          		ADC_B_DCOB,
	input 		    [13:0]		ADC_B_D,
	input 		          		ADC_B_ORB,
	input 		          		ADC_C_DCOC,
	input 		    [13:0]		ADC_C_D,
	input 		          		ADC_C_ORC,
	input 		          		ADC_D_DCOD,
	input 		    [13:0]		ADC_D_D,
	input 		          		ADC_D_ORD,
	output		          		FPGA_CLK_ADC1_p,
	output		          		FPGA_CLK_ADC2_p,
	input  		          		SI5340B_INTR,
	output  		          		SI5340B_I2C_SCL,
	inout  		          		SI5340B_I2C_SDA,
	output 		          		SI5340B_OE_n,
	output 		          		SI5340B_RST_n,

	//////////// FMC Reserved Pins //////////
	inout 		     [0:0]		FMC_RES
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [7:0 ] CHIP_ID1;
wire [7:0 ] CHIP_ID2; 
wire        READY1;
wire        READY2;
wire        SP_CLK;
wire [7:0]  HZ; 
wire        M50_1HZ; 
wire [35:0] FREQ_OSC_50_B4D;    
wire [35:0] FREQ_ADC_A_DCOA;  
wire [35:0] FREQ_ADC_B_DCOB;
wire [35:0] FREQ_ADC_C_DCOC;
wire [35:0] FREQ_ADC_D_DCOD;
wire [35:0] FREQ_FPGA_CLK_ADC1_p;
wire [35:0] FREQ_FPGA_CLK_ADC2_p;
reg   [1:0] rrSW ;
wire        KEYTM ; 
wire        START ; 
wire        si5340b_config_done;
wire        CLOCK_LOCK;
wire        SPI_READY ;
wire        SPI_READY1;
wire        SPI_READY2;
wire        CLOCK_READY ;
wire        RST_PD_N ;
wire        RST_SPI_N; 
wire  [1:0] BUTTON_;

//=======================================================
//  Structural coding
//=======================================================

//--------BUTTON's DEBONCE ----
DEBONCE d0( .CLK(CLK_50_B2L) , .iD(BUTTON[0]), .oD(BUTTON_[0]));
DEBONCE d1( .CLK(CLK_50_B2L) , .iD(BUTTON[1]), .oD(BUTTON_[1]));

//--------SI5341A ----
assign SI5341A_I2C_SCL=1'bz;
assign SI5341A_I2C_SDA=1'bz;
assign SI5341A_OE_n  = 1'b0;
assign SI5341A_RST_n = 1'b1;

//--------SW trigger reset ----
always@( posedge CLK_50_B2L  ) rrSW <= SW ;
assign  KEYTM  =  (rrSW != SW)? 0 : 1; 

//--------RESET_DELAY ----
 RESET_DELY dl( 
   .BUTTON_N  ( KEYTM ), 
	.OSC_50    (CLK_50_B2L), 
   .RST_DLY1  (RST_PD_N ),
   .RST_DLY2  (RST_SPI_N)
) ; 

//--------ADC Clock Slection ----
//00: Si5340 Clock  
//10: FPGA Clock 
assign ADC1_CK_S[1:0] =SW[1:0] ;
assign ADC2_CK_S[1:0] =SW[1:0] ;
 

//--------PLL & SI5340 clock  set ok! ----  
assign CLOCK_READY  = si5340a0_config_done & CLOCK_LOCK ;  
 
//--------si5340a0 clock set ----
assign SI5340B_RST_n =1; 
assign SI5340B_OE_n  =0;

`define XCVR_REF_50M           4'h0
`define XCVR_REF_70M           4'h1
`define XCVR_REF_150M          4'h2
`define XCVR_REF_125M          4'h3
`define XCVR_REF_100M          4'h4
`define XCVR_REF_40M           4'h9

//--SI5340A0 start Config delay
RESET_DELY d3( 
   .BUTTON_N  ( SPI_READY ), 
	.OSC_50    ( CLK_50_B2L), 
   .START     ( START )
) ;

//--Configure SI5340A0 
assign  SET   =`XCVR_REF_125M; 
SI5340A_CONFIG si5340a0_controller(
    .iCLK         ( CLK_50_B2L   ),
    .iRST_n       ( SPI_READY    ),
    .iStart       ( START        ),
    .iXCVR0_REFCLK(`XCVR_REF_125M),
    .iXCVR1_REFCLK(`XCVR_REF_125M),
    .iMEM0_REFCLK (`XCVR_REF_125M),
    .iMEM1_REFCLK (`XCVR_REF_125M),
    .I2C_DATA     (SI5340B_I2C_SDA),
    .I2C_CLK      (SI5340B_I2C_SCL),
    .oPLL_REG_CONFIG_DONE(si5340a0_config_done)
);

//--ADC CHIP Control---
assign  ADC1_PDWN = ~RST_PD_N  ;      //1: POWER DOWN  , 0: 1: NO POWER DOWN  
assign  ADC1_SYNC = 1;
assign  ADC1_OEB  = ~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
assign  ADC2_PDWN = ~RST_PD_N  ;      //1: POWER DOWN  , 0: 1: NO POWER DOWN
assign  ADC2_SYNC = 1;
assign  ADC2_OEB  = ~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
 
//--SPI WRITE/READ 
// 1) read ADC IC (AD9648) ID(0x01) /GRADE(0x02) , 
// 2) set Output mode (0x14) , set to  twos complement
// 3) set Power mode (0x08) digital reset/ normal operation . (Clock Stability Considerations see data sheet page40 ) 
assign SPI_READY  = SPI_READY1 & SPI_READY2 ; 
SPI_SET_2CH  SPI(
    .OSC_50        (CLK_50_B2L    ), 
    .RESET_N       (RST_SPI_N     ), 
    .ADC1_SDIO_DCS (ADC1_SDIO_DCS ),
    .ADC1_CSB      (ADC1_CSB      ),
    .ADC1_SCLK_DFS (ADC1_SCLK_DFS ),
    .ADC2_SDIO_DCS (ADC2_SDIO_DCS ),
    .ADC2_CSB      (ADC2_CSB      ),
    .ADC2_SCLK_DFS (ADC2_SCLK_DFS ),
    .CHIP_ID1      (CHIP_ID1      ),
    .CHIP_ID2      (CHIP_ID2      ),
	 .READY1        (SPI_READY1    ), // 1: ADC1 SPI write/read ready 
	 .READY2        (SPI_READY2    )  // 1: ADC1 SPI write/read ready  
);		
		
//--FPGA 12MhzCLOCK Generater
PLL125 pl1( 
	.refclk  ( CLK_50_B2L      ),
	.rst     ( 1'b0            ),
	.outclk_0( FPGA_CLK_ADC1_p ),
	.outclk_1( FPGA_CLK_ADC2_p ),
	.locked  ( CLOCK_LOCK      ) 
	) ; 

//--4CH ADC DATA FIFO 	
assign  SP_CLK = ADC_A_DCOA ;
FIFO fifoa( .aclr(~CLOCK_READY | ~BUTTON_[0]),.data (ADC_A_D), .wrclk(ADC_A_DCOA),.rdclk(SP_CLK),.q());
FIFO fifob( .aclr(~CLOCK_READY | ~BUTTON_[0]),.data (ADC_B_D), .wrclk(ADC_B_DCOB),.rdclk(SP_CLK),.q());
FIFO fifoc( .aclr(~CLOCK_READY | ~BUTTON_[0]),.data (ADC_C_D), .wrclk(ADC_C_DCOC),.rdclk(SP_CLK),.q());
FIFO fifod( .aclr(~CLOCK_READY | ~BUTTON_[0]),.data (ADC_D_D), .wrclk(ADC_D_DCOD),.rdclk(SP_CLK),.q());

  
//-------1HZ heart genearter  
CLOCKMEM hz_CLK_50_B2L     (  .RESET_n(BUTTON_[1]), .CLK(CLK_50_B2L      ),.CLK_FREQ  (50000000),  .CK_1HZ(HZ[0]) ) ;  
CLOCKMEM hz_ADC_A_DCOA     (  .RESET_n(BUTTON_[1]), .CLK(ADC_A_DCOA      ),.CLK_FREQ  (125000000), .CK_1HZ(HZ[1]) ) ; 
CLOCKMEM hz_ADC_B_DCOB     (  .RESET_n(BUTTON_[1]), .CLK(ADC_B_DCOB      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[2]) ) ; 
CLOCKMEM hz_ADC_C_DCOC     (  .RESET_n(BUTTON_[1]), .CLK(ADC_C_DCOC      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[3]) ) ; 
CLOCKMEM hz_ADC_D_DCOD     (  .RESET_n(BUTTON_[1]), .CLK(ADC_D_DCOD      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[4]) ) ; 
CLOCKMEM hz_FPGA_CLK_ADC1_p(  .RESET_n(BUTTON_[1]), .CLK(FPGA_CLK_ADC1_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[5]) ) ; 
CLOCKMEM hz_FPGA_CLK_ADC2_p(  .RESET_n(BUTTON_[1]), .CLK(FPGA_CLK_ADC2_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[6]) ) ; 
CLOCKMEM hz_SMA_CLKIN_p    (  .RESET_n(BUTTON_[1]), .CLK(SMA_CLKIN_p     ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[7]) ) ; 

//--Heart of DCO Clock of ADC2 & ADC1  
assign LED =( (CHIP_ID1==8'h88)&& (CHIP_ID2==8'h88) ) ? {HZ[3],HZ[1]} :0 ;

//---------------FREQ TEST -------------------
CLOCKMEM      ck2           ( .RESET_n(BUTTON_[0]),.CLK     (CLK_50_B2L      )   , .CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;
FRE_MEASURE fOSC_50_B4D     ( .RESET_n(BUTTON_[0]),.MES_CLK (OSC_50_B4D      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_OSC_50_B4D     ) ); 
FRE_MEASURE fADC_A_DCOA     ( .RESET_n(BUTTON_[0]),.MES_CLK (ADC_A_DCOA      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_A_DCOA     ) ); 
FRE_MEASURE fADC_B_DCOB     ( .RESET_n(BUTTON_[0]),.MES_CLK (ADC_B_DCOB      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_B_DCOB     ) ); 
FRE_MEASURE fADC_C_DCOC     ( .RESET_n(BUTTON_[0]),.MES_CLK (ADC_C_DCOC      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_C_DCOC     ) ); 
FRE_MEASURE fADC_D_DCOD     ( .RESET_n(BUTTON_[0]),.MES_CLK (ADC_D_DCOD      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_D_DCOD     ) ); 
FRE_MEASURE fFPGA_CLK_ADC1_p( .RESET_n(BUTTON_[0]),.MES_CLK (FPGA_CLK_ADC1_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC1_p) );
FRE_MEASURE fFPGA_CLK_ADC2_p( .RESET_n(BUTTON_[0]),.MES_CLK (FPGA_CLK_ADC2_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC2_p) ); 								

endmodule
