module fmc_sel (  
 input [3:0]   SEL, 
 output [2:0]  MUX, 
 output        FORCE2, 
 output [23:0] R_REG
 
 );
//`define XCVR_REF_644M53125     4'h0  // for Ethernet
//`define XCVR_REF_322M265625    4'h1  // for Ethernet  
//`define XCVR_REF_250M          4'h2 
//`define XCVR_REF_125M          4'h3  
//`define XCVR_REF_100M          4'h4  
//`define XCVR_REF_270M          4'h5  // for Displayport 
 
 
assign MUX = ( 
   (SEL==0) ? 1 :  (//644M
   (SEL==1) ? 1 :  (//322M
   (SEL==2) ? 0 :  (//250M
   (SEL==3) ? 0 :  (//125M
   (SEL==4) ? 0 :  (//100M
   (SEL==5) ? 2 :  2//270M
	))))));

assign FORCE2  = ( 
   (SEL==0) ? 1 :  (//644M
   (SEL==1) ? 0 :  (//322M
   (SEL==2) ? 0 :  (//250M
   (SEL==3) ? 0 :  (//125M
   (SEL==4) ? 0 :  (//100M
   (SEL==5) ? 1 :  1//270M
	))))));
assign R_REG = (
   (SEL==0) ? 0 :  (//644M
   (SEL==1) ? 1 :  (//322M
   (SEL==2) ? 1 :  (//250M
   (SEL==3) ? 3 :  (//125M
   (SEL==4) ? 4 :  (//100M
   (SEL==5) ? 0 :  0//270M
	))))));
	
endmodule 	