module si5341a_freq_prameter_selector (

input         [3:0]          iPLL_OUT_FREQ_SEL,

output   reg  [23:0]         RX_REG,
output   reg                 OUTX_OE,
output   reg  [43:0]         NX_NUM,
output   reg  [31:0]         NX_DEN       

);
//`define XCVR_REF_644M53125     4'h0  // for Ethernet
//`define XCVR_REF_322M265625    4'h1  // for Ethernet  
//`define XCVR_REF_250M          4'h2 
//`define XCVR_REF_125M          4'h3  
//`define XCVR_REF_100M          4'h4  
//`define XCVR_REF_270M          4'h5  // for Displayport
//
//`define MEM_REF_300M           4'h0+6 // for DDR4 2400 MT/s (Dual Rank: default)
//`define MEM_REF_166M667        4'h1+6 // for DDR4 2666 MT/s (Single Rank)
//
//`define LVDS_REF_50M           4'h0+8 // ref clock for LVDS IP
//`define LVDS_REF_100M          4'h1+8 // ref clock for LVDS IP
// 1152.00   Mhz=644.53125
// 2304.00   Mhz=322.265625
// 2970.00   Mhz=250
// 5940.00   Mhz=125
// 7425.00   Mhz=100
// 2750.00   Mhz=270
// 2475.00   Mhz=300
// 4455.00   Mhz=166.66667
// 14850.00  Mhz=50
// 7425.00   Mhz=100           


always @(*)
  begin
     case(iPLL_OUT_FREQ_SEL[3:0])
	  //--------------------XCVR -----------------------------
      4'h0 :   //644.53125 MHz
        begin
          OUTX_OE <= 1'b1 ;
          RX_REG  <= 24'd1152;
        end
      4'h1 :   //322.265625 MHz
        begin
          OUTX_OE <= 1'b1 ;
          RX_REG  <= 24'd2304;
        end
      4'h2 :   //250.0 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd2970;

        end
      4'h3 :   //125.0 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd5940;
        end                     
      4'h4 :   //100.0 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd7425;
        end               
      4'h5 :   //270.0 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd2750;
        end               
		  
		 //--------------------MEM ----------------------------- 
      4'h6 :   //300.0 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd2475;
        end               
      4'h7 :   //166.667 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd4455;
        end        
		  
	  //--------------------LVDS -----------------------------		  
		  
      4'h8 :   //50 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd14850;
        end               
		
      4'h9 :   //100 MHz
        begin
          OUTX_OE <= 1'b1;
          RX_REG  <= 24'd7425;
        end               
		  		  
      default :   //100Mhz
        begin
          OUTX_OE = 1'b1;
          RX_REG = 24'd152253235200;
        end                         
      endcase
  end
  

endmodule
