module RESET_DELY ( 
   input BUTTON_N  , 
	input OSC_50 , 
   output reg RST_DLY1 ,   
   output reg RST_DLY2 ,   
   output reg RST_DLY3,
   output START     	 
) ; 

parameter SEC = 50000000 ; 
parameter SEC2 = 2*SEC  ; 

//=======================================================
//  REG/WIRE declarations
//=======================================================
reg [31:0] DELAY_CNT  ; 
  
//=======================================================
//  Structural coding
//=======================================================	

assign START  = ( ( DELAY_CNT > SEC ) & ( DELAY_CNT< ( SEC+SEC/2 )) ) ?1:0 ; 

always @(negedge  BUTTON_N or posedge OSC_50  ) 
 if (  !BUTTON_N ) begin 
      DELAY_CNT<=0;
      RST_DLY1<=0;
	   RST_DLY2<=0;
	   RST_DLY3<=0;
 end
 else  begin 
      if ( DELAY_CNT < SEC2 ) DELAY_CNT <= DELAY_CNT+1; 
		     if ( DELAY_CNT ==SEC/10 ) RST_DLY1<=1;// 0.1S
		else if ( DELAY_CNT ==SEC/5  ) RST_DLY2<=1;// 0.2S
 end 
endmodule 