// ============================================================================
// Copyright (c) 2016 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Mar 16 09:30:16 2016
// ============================================================================

//`define ENABLE_DDR3
//`define ENABLE_PCIE
//`define ENABLE_SATA
`define DDR3_RANK_NUM   1  //2
module TR5_golden_top(

      ///////// CLOCK /////////
      input              OSC_50_B3B,
      input              OSC_50_B4A,
      input              OSC_50_B4D,
      input              OSC_50_B7A,
      input              OSC_50_B7D,
      input              OSC_50_B8A,
      input              OSC_50_B8D,

      ///////// KEY /////////
      input              CPU_RESET_n,
      input    [ 3: 0]   BUTTON, //KEY is Low-Active

      ///////// SW /////////
      input    [ 3: 0]   SW,

      ///////// LED /////////
      output   [ 3: 0]   LED, //LED is Low-Active

      ///////// FAN /////////
      input              FAN_ALERT_n,

      ///////// SSRAM /////////
      output             SSRAM_CLK,
      output             SSRAM_CKE_n,
      output             SSRAM_CE_n,
      output             SSRAM_WE_n,
      output             SSRAM_OE_n,
      output             SSRAM_ADV,
      output             SSRAM_BWA_n,
      output             SSRAM_BWB_n,

      ///////// FLASH /////////
      output             FLASH_CLK,
      output             FLASH_CE_n,
      output             FLASH_WE_n,
      output             FLASH_OE_n,
      output             FLASH_ADV_n,
      output             FLASH_RESET_n,
      input              FLASH_RDY_BSY_n,

      ///////// FSM /////////
      output   [26: 0]   FSM_A,
      inout    [15: 0]   FSM_D,

      ///////// SD Card /////////
      output             SD_CLK,
      inout    [ 3: 0]   SD_DATA,
      inout              SD_CMD,

`ifdef ENABLE_DDR3
      ///////// DDR3 /////////
      input              DDR3_REFCLK_p,
      output   [15: 0]   DDR3_A,
      output   [ 2: 0]   DDR3_BA,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CK,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CK_n,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CKE,
      inout    [ 7: 0]   DDR3_DQS,
      inout    [ 7: 0]   DDR3_DQS_n,
      inout    [63: 0]   DDR3_DQ,
      output   [ 7: 0]   DDR3_DM,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CS_n,
      output             DDR3_WE_n,
      output             DDR3_CAS_n,
      output             DDR3_RAS_n,
      output             DDR3_RESET_n,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_ODT,
      input              DDR3_EVENT_n,
      output             DDR3_SCL,
      inout              DDR3_SDA,
`endif /*ENABLE_DDR3*/

      ///////// RZQ /////////
      input              RZQ_DDR3,
      input              RZQ_FMC,

      ///////// Uart to USB /////////
      output             UART_TX,
      input              UART_RX,

      ///////// TPS40422 /////////
      output             TPS40422_CLK,
      inout              TPS40422_DATA,
      input              TPS40422_ALERT,

      ///////// External PLL /////////
      output             LMK04906_CLK,
      output             LMK04906_DATAIN,
      input              LMK04906_DATAOUT,
      output             LMK04906_LE,

      ///////// I2C /////////
      output             CLOCK_SCL,
      inout              CLOCK_SDA,

      ///////// Shared I2C /////////
      inout              FPGA_I2C_SCL,
      inout              FPGA_I2C_SDA,

      ///////// Temperature /////////
      input              TEMP_INT_n,
      input              TEMP_OVERT_n,

      ///////// POWER Monitor /////////
      input              POWER_MONITOR_ALERT,

      ///////// GPIO /////////
      inout    [35: 0]   GPIO,


`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      input              PCIE_ONBOARD_REFCLK_p,
      input              PCIE_REFCLK_p,
      output   [ 3: 0]   PCIE_TX_p,
      input    [ 3: 0]   PCIE_RX_p,
      input              PCIE_PERST_n,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_SATA
      ///////// SATA /////////
      input              SATA_HOST_REFCLK_p,
      output             SATA_HOST_TX_p,
      input              SATA_HOST_RX_p,
      input              SATA_DEVICE_REFCLK_p,
      output             SATA_DEVICE_TX_p,
      input              SATA_DEVICE_RX_p, 
`endif /*ENABLE_SATA*/


      ///////// FMCD/////////
//-----------fmc-----------  
       inout Si5340B_I2C_SDA,
       inout Si5340B_I2C_SCL,
       input Si5340B_INTR,
       output  Si5340B_RST_n,
       output  Si5340B_OE_n ,
       
		 //--LPC
       input [13:0] ADC_A_D , 
       input [13:0] ADC_B_D , 
       input ADC_A_ORA,
       input ADC_B_ORB,
       input ADC_A_DCOA,
       input ADC_B_DCOB ,
       output ADC1_PDWN,
       inout  ADC1_SDIO_DCS,
       output [1:0]ADC1_CK_S,
       output ADC1_SCLK_DFS,
       output ADC1_CSB,
       output ADC1_OEB,
       output ADC1_SYNC,
       output FPGA_CLK_ADC1_p,
      // output FPGA_CLK_ADC1_n,
		 
		 //--HPC
       input [13:0] ADC_C_D , 
       input [13:0] ADC_D_D , 
       input ADC_C_ORC,
       input ADC_D_ORD,
       input ADC_C_DCOC,
       input ADC_D_DCOD ,
       output ADC2_PDWN,
       inout  ADC2_SDIO_DCS,
       output [1:0]ADC2_CK_S,
       output ADC2_SCLK_DFS,
       output ADC2_CSB,
       output ADC2_OEB,
       output ADC2_SYNC,
       output FPGA_CLK_ADC2_p,
       //output FPGA_CLK_ADC2_n,
		 
	 
	
      ///////// SMA /////////
      input              SMA_CLKIN_p,
      output             SMA_CLKOUT_p,
      output             SMA_CLKOUT_n
		
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire        PDWN; 
wire [7:0 ] CHIP_ID1;
wire [7:0 ] CHIP_ID2; 
wire        READY1;
wire        READY2;
wire        SP_CLK;
wire [7:0]  HZ; 
wire        M50_1HZ; 
wire        CLK_400M ; 
wire [35:0] FREQ_OSC_50_B4D;    
wire [35:0] FREQ_ADC_A_DCOA;  
wire [35:0] FREQ_ADC_B_DCOB;
wire [35:0] FREQ_ADC_C_DCOC;
wire [35:0] FREQ_ADC_D_DCOD;
wire [35:0] FREQ_FPGA_CLK_ADC1_p;
wire [35:0] FREQ_FPGA_CLK_ADC2_p;
wire        CLOCK_LOCK ; 

//=======================================================
//  Structural coding
//=======================================================


//-- Si5340B release 
assign Si5340B_I2C_SDA =1'bz;
assign Si5340B_I2C_SCL =1'bz;	
assign Si5340B_RST_n   =1'b1;
assign Si5340B_OE_n    =1'b0;	


//--ADC CHIP Control---
assign  PDWN  = ~BUTTON[1] ; 

//---ADC Clock Slection , 
//00: Si5340 
//01: SMA  CLOCK 
//10: FPGA CLOCK 
assign ADC1_CK_S[1:0] =SW[1:0] ; 
assign ADC2_CK_S[1:0] =SW[1:0] ; 

//--ADC Control
assign  ADC1_PDWN =PDWN  ;           //1: POWER DOWN  , 0: 1: NO POWER DOWN  
assign  ADC1_SYNC =1;
assign  ADC1_OEB  =~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
assign  ADC2_PDWN =PDWN  ;           //1: POWER DOWN  , 0: 1: NO POWER DOWN
assign  ADC2_SYNC =1;
assign  ADC2_OEB  =~CLOCK_LOCK;      //OEB pin is low, the output data drivers and DCOs are enabled. 
 

//--SPI WRITE/READ 
// 1) read ADC IC (AD9648) ID(0x01) /GRADE(0x02) , 
// 2) set Output mode (0x14) , set to  twos complement
// 3) set Power mode (0x08) digital reset/ normal operation . (Clock Stability Considerations see data sheet page40 ) 
SPI_SET_2CH  rt(
    .OSC_50        (OSC_50_B3B ), 
    .RESET_N        (BUTTON[0]    ), 
    .ADC1_SDIO_DCS (ADC1_SDIO_DCS ),
    .ADC1_CSB      (ADC1_CSB      ),
    .ADC1_SCLK_DFS (ADC1_SCLK_DFS ),
    .ADC2_SDIO_DCS (ADC2_SDIO_DCS),
    .ADC2_CSB      (ADC2_CSB     ),
    .ADC2_SCLK_DFS (ADC2_SCLK_DFS),
    .CHIP_ID1      (CHIP_ID1),
    .CHIP_ID2      (CHIP_ID2),
	 .READY1        (READY1) , // 1: ADC1 SPI write/read ready 
	 .READY2        (READY2)   // 1: ADC1 SPI write/read ready  
);				
								
//--LED Display 						 
assign LED =((CHIP_ID1==8'h88) && ( CHIP_ID2==8'h88 )) ?  HZ[4:1] :4'hF  ;


//--FPGA CLOCK Generater
PLL125 pl1( 
	.refclk  (OSC_50_B8D),
	.rst     (1'b0),
	.outclk_0(FPGA_CLK_ADC1_p),
	.outclk_1(FPGA_CLK_ADC2_p),
	.locked  (CLOCK_LOCK) ) ; 
	
	
//--SMA 	CLOCK output
assign SMA_CLKOUT_p	  = FPGA_CLK_ADC1_p ; 
assign SMA_CLKOUT_n    = FPGA_CLK_ADC2_p ; 
	
	
//--4CH ADC DATA FIFO 	
FIFO da( .aclr(~CLOCK_LOCK),.data (ADC_A_D), .wrclk(ADC_A_DCOA),.rdclk(SP_CLK),.q());
FIFO db( .aclr(~CLOCK_LOCK),.data (ADC_B_D), .wrclk(ADC_B_DCOB),.rdclk(SP_CLK),.q());
FIFO dc( .aclr(~CLOCK_LOCK),.data (ADC_C_D), .wrclk(ADC_C_DCOC),.rdclk(SP_CLK),.q());
FIFO dd( .aclr(~CLOCK_LOCK),.data (ADC_D_D), .wrclk(ADC_D_DCOD),.rdclk(SP_CLK),.q());




assign  SP_CLK = ADC_A_DCOA ;
  
//-------1HZ heart genearter  
CLOCKMEM k0(  .RESET_n(BUTTON[1]), .CLK(OSC_50_B4D      ),.CLK_FREQ  (50000000),  .CK_1HZ(HZ[0]) ) ;  
CLOCKMEM k00( .RESET_n(BUTTON[1]), .CLK(ADC_A_DCOA      ),.CLK_FREQ  (125000000), .CK_1HZ(HZ[1]) ) ; 
CLOCKMEM k1(  .RESET_n(BUTTON[1]), .CLK(ADC_B_DCOB      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[2]) ) ; 
CLOCKMEM k3(  .RESET_n(BUTTON[1]), .CLK(ADC_C_DCOC      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[3]) ) ; 
CLOCKMEM k4(  .RESET_n(BUTTON[1]), .CLK(ADC_D_DCOD      ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[4]) ) ; 
CLOCKMEM k5(  .RESET_n(BUTTON[1]), .CLK(FPGA_CLK_ADC1_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[5]) ) ; 
CLOCKMEM k6(  .RESET_n(BUTTON[1]), .CLK(FPGA_CLK_ADC2_p ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[6]) ) ; 
CLOCKMEM k7(  .RESET_n(BUTTON[1]), .CLK(SMA_CLKIN_p     ) ,.CLK_FREQ (125000000), .CK_1HZ(HZ[7]) ) ; 


//---------------FREQ TEST -------------------
CLOCKMEM  ck2( .RESET_n(BUTTON[0]), .CLK(OSC_50_B4D ) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;
FRE_MEASURE mes1 ( .RESET_n(BUTTON[0]),.MES_CLK (OSC_50_B4D      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_OSC_50_B4D     ) ); 
FRE_MEASURE mes4 ( .RESET_n(BUTTON[0]),.MES_CLK (ADC_A_DCOA      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_A_DCOA     ) ); 
FRE_MEASURE mes6 ( .RESET_n(BUTTON[0]),.MES_CLK (ADC_B_DCOB      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_B_DCOB     ) ); 
FRE_MEASURE mes3 ( .RESET_n(BUTTON[0]),.MES_CLK (ADC_C_DCOC      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_C_DCOC     ) ); 
FRE_MEASURE mes7 ( .RESET_n(BUTTON[0]),.MES_CLK (ADC_D_DCOD      )   , .HZ1(M50_1HZ) , .FREQ(FREQ_ADC_D_DCOD     ) ); 
FRE_MEASURE mes12( .RESET_n(BUTTON[0]),.MES_CLK (FPGA_CLK_ADC1_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC1_p) );
FRE_MEASURE mes13( .RESET_n(BUTTON[0]),.MES_CLK (FPGA_CLK_ADC2_p )   , .HZ1(M50_1HZ) , .FREQ(FREQ_FPGA_CLK_ADC2_p) ); 																																
PLL400  TT(
	.rst      (~BUTTON[0]),
	.refclk   (OSC_50_B4D),
	.locked   (),
	.outclk_0 (CLK_400M) );			  
TP t(
    .SP_CLK              ( SP_CLK )  ,
    .CLK                 ( CLK_400M           ),
    .TR                  ( M50_1HZ            ), 
	 .ADC1_CK_S           ( ADC1_CK_S[1:0]     ),
	 .ADC2_CK_S           ( ADC2_CK_S[1:0]     ),
    .FREQ_OSC_50_B4D     (FREQ_OSC_50_B4D     ), 
    .FREQ_ADC_A_DCOA     (FREQ_ADC_A_DCOA     ), 
    .FREQ_ADC_B_DCOB     (FREQ_ADC_B_DCOB     ),
    .FREQ_ADC_C_DCOC     (FREQ_ADC_C_DCOC     ),
    .FREQ_ADC_D_DCOD     (FREQ_ADC_D_DCOD     ) ,
    .FREQ_FPGA_CLK_ADC1_p(FREQ_FPGA_CLK_ADC1_p ),
	 .FREQ_FPGA_CLK_ADC2_p(FREQ_FPGA_CLK_ADC2_p )
	 ) ;  
	      
endmodule
